/**
 * Created by Renat Fazilyanov(cptrnt@mail.ru) on 23.05.18.
 */
'use strict';

Object.defineProperties( Array.prototype, {

    randomElement: {
        value: function () {
            return this[ Math.round( Math.random() * (this.length - 1) ) ]
        },
        enumerable : false,
        writable : true
    },

    delete: {
        value: function ( elm ) {

            let index = this.indexOf( elm );
            if( index == -1 ){
                return this;
            }

            this.splice(index, 1);

            return this;
        },
        enumerable : false,
        writable : true
    },

    equal: {
        value: function ( arr ) {

            if( this.length !== arr.length ){
                return false;
            }

            for( let i=0; i < arr.length; i++ ){

                if( typeof this[i] !== 'object' && this[i] !== arr[i] ||
                    typeof this[i] !== typeof arr[i] ||
                    Array.isArray( this[i] )   !==  Array.isArray( arr[i] ) ||
                    Array.isArray( this[i] )    &&  !this[i].equal( arr[i] ) ||
                    typeof this[i] === 'object' &&  this[i].diffFrom( arr[i] ) ){

                    return false;

                }
            }

            return true;
        },
        enumerable : false,
        writable : true
    }

} );
